/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_nodedelone.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gbersac <gbersac@student.42.fr>            +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2013/11/28 10:42:15 by gbersac           #+#    #+#             */
/*   Updated: 2013/12/05 14:23:10 by gbersac          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "libft.h"

static void	change_father_son(t_node *to_del)
{
	if (to_del->parent == NULL)
		return ;
	if (to_del->parent->son == to_del)
		to_del->parent->son = to_del->brother;
}

static int	exclude_brother(t_node *previous, t_node *to_del)
{
	if (previous == NULL)
		return (0);
	previous->brother = to_del->brother;
	return (0);
}

/* Return 1 if error occured. Error if node is not in its parent sons' list.
*/
static int	exclude_from_brother(t_node *to_del)
{
	t_node	*parent;
	t_node	*brother;
	t_node	*previous_brother;

	parent = to_del->parent;
	if (parent == NULL)
		return (0);
	brother = parent->son;
	previous_brother = NULL;
	while (brother != NULL)
	{
		if (brother == to_del)
			return (exclude_brother(previous_brother, to_del));
		previous_brother = brother;
		brother = brother->brother;
	}
	return (1);
}

int			ft_nodedelone(t_node **anode, void (*del)(void *, size_t))
{
	t_node	*to_del;
	int		ret;

	if (anode == NULL || *anode == NULL)
		return (0);
	to_del = *anode;
	del(to_del->content, to_del->content_size);
	ret = exclude_from_brother(to_del);
	if (ret != 0)
		return (ret);
	change_father_son(to_del);
	return (0);
}
