#include "test_list.h"

void	my_free(void *m, size_t n)
{
	n = 1;
	free(m);
}

void	display_test(const char *str, char separator)
{
	t_list	*lst;

	lst = NULL;
	lst = ft_strsplit_lst(str, separator);
	printf("result (separator = ###) : \n");
	ft_putlststr(lst, "###");
	ft_lstdel(&lst, my_free);
	printf("\n\n");
}

void	unit_lstnew(void const *content, size_t content_size)
{
	t_list	*result;
	result = ft_lstnew(content, content_size);
	if (ft_strcmp((char*) content, (char*) result->content) != 0)
	{
		printf("pour : \'%s\' result %s\n", (char*) content,
				(char*) result->content);
		printf("!!!!!!!!!!!!ERROR!!!!!!!!!!!!\n");
	}
	else
	{
		printf("fonctionne pour \'%s\'\n", (char*) content);
	}
}

void	test_lstnew()
{
	printf("\n@@@@@@@@@@@@@TEST STRLEN\n");
	unit_lstnew("123456789", 11);
	unit_lstnew("", 1);
}

void	unit_display_test(const char *content, char separator)
{
	printf("test pour \'%s\' separator %c\n", content, separator);
	display_test(content, separator);
}

void	test_display_test()
{
	printf("\n@@@@@@@@@@@@@TEST putlststr_fd putlststr strsplit_lst lstaddq\n");
	unit_display_test("123+456+789", '+');
	unit_display_test("123+456+789+", '+');
	unit_display_test("123+456+789+", 'a');
	unit_display_test("", '+');
}

void	up(t_list *lst)
{
	if (lst->content_size > 2)
	{
		char	*str;
		str = lst->content;
		str[0] = 'a';
	}
}

void	unit_lstiter(char *str, char separator)
{
	t_list	*lst;

	printf("test pour \'%s\' separator %c\n", str, separator);
	lst = NULL;
	lst = ft_strsplit_lst(str, separator);
	ft_lstiter(lst, up);
	printf("result (separator = ###) : \n");
	ft_putlststr(lst, "###");
	ft_lstdel(&lst, my_free);
	printf("\n\n");
}

void	test_lstiter()
{
	printf("\n@@@@@@@@@@@@@TEST lstiter\n");
	unit_lstiter("123+456+789", '+');
	unit_lstiter("", '+');
}

uchar	cmp(t_list *l1, t_list *l2)
{
	char	*a;
	char	*b;

	a = (char*) l1->content;
	b = (char*) l2->content;
	return (*a > *b);
}

void	unit_mergesort(char *str, char separator,
		uchar (*cmp)(t_list*, t_list*))
{
	t_list	*lst;

	printf("test pour \'%s\' separator %c\n", str, separator);
	lst = NULL;
	lst = ft_strsplit_lst(str, separator);
	lst = ft_mergesort(lst, cmp);
	printf("end result (separator = ###) : \n");
	ft_putlststr(lst, ".");
	ft_lstdel(&lst, my_free);
	printf("\n\n");
}

void	test_mergesort()
{
	printf("\n@@@@@@@@@@@@@TEST mergesort\n");
	unit_mergesort("2+5+7+9+8+3+1+4+6", '+', cmp);
	unit_mergesort("2+5+4+7+9+4+8+3+4+1+4+6", '+', cmp);
	unit_mergesort("", '+', cmp);
}
