#include "test_memory.h"

#define	MEM_LENGTH	10

static void	*cpymem(void *mem)
{
	char	*ptr;

	ptr = ft_strdup((char*) mem);
	return ((void*) ptr);
}

static void	*initmem2(int length, char c)
{
	char	*ptr;
	int 	i;

	ptr = malloc(length + 1);
	i = 0;
	while (i < length)
	{
		ptr[i] = c;
		++i;
	}
	ptr[length] = '\0';
	return ((void*) ptr);
}

static void *initmem(int length)
{
	return (initmem2(length, '0'));
}

void	compare_memset(char *test, int value, size_t length)
{
	void	*result_perso, *result_std;

	printf("\ntest : %s \n", test);
	result_perso = ft_memset(cpymem(test), value, length);
	result_std = memset(cpymem(test), value, length);
	print_result((char*) result_std, (char*) result_perso);
	free(test);
	free(result_perso);
	free(result_std);
}

void	test_memset()
{
	printf("\n@@@@@@@@@@@@@TEST memset\n");
	compare_memset(initmem(10), '1', 10);
	compare_memset(initmem(10), '1', 20);
	compare_memset(initmem(10), 305, 10);
	compare_memset(initmem(10), '1', 5);
}

void	compare_bzero(char *test, size_t length)
{
	void	*result_perso, *result_std;

	printf("\ntest : %s\n", test);
	result_perso = cpymem(test);
	result_std = cpymem(test);
	ft_bzero(result_perso, length);
	bzero(result_std, length);
	print_result((char*) result_std, (char*) result_perso);
	free(test);
	free(result_perso);
	free(result_std);
}

void	test_bzero()
{
	printf("\n@@@@@@@@@@@@@TEST bzero\n");
	compare_bzero(initmem(10), 10);
	compare_bzero(initmem(10), 20);
	compare_bzero(initmem(10), 10);
	compare_bzero(initmem(10), 5);
}

void	compare_memcpy(char *test, char *s2, size_t length)
{
	void	*result_perso, *result_std;

	printf("\ncpy : %s sur %s sur %zi\n", s2, test, length);
	result_perso = cpymem(test);
	result_std = cpymem(test);
	ft_memcpy(result_perso, s2, length);
	memcpy(result_std, s2, length);
	print_result((char*) result_std, (char*) result_perso);
	free(test);
	free(result_perso);
	free(result_std);
}

void	test_memcpy()
{
	printf("\n@@@@@@@@@@@@@TEST memcpy\n");
	compare_memcpy(initmem(10), initmem2(10, 'a'), 10);
	compare_memcpy(initmem(10), initmem2(10, 'a'), 5);
	compare_memcpy(initmem(10), initmem2(10, 'a'), 20);
}

void	compare_memccpy(char *test, char *s2, int c, size_t length)
{
	void	*result_perso, *result_std;
	void	*cpy_perso, *cpy_std;

	printf("\ncpy : %s sur %s sur %zi fin %i\n", s2, test, length, c);
	cpy_perso = cpymem(test);
	cpy_std = cpymem(test);
	result_perso = ft_memccpy(cpy_perso, s2, c, length);
	result_std = memccpy(cpy_std, s2, c, length);
	print_result((char*) result_std, (char*) result_perso);
	print_result((char*) cpy_std, (char*) cpy_perso);
	free(cpy_perso);
	free(cpy_std);
}

void	test_memccpy()
{
	char	*s2;

	s2 = (char*) initmem2(10, 'a');
	s2[5] = 'b';
	printf("\n@@@@@@@@@@@@@TEST memccpy\n");
	compare_memccpy(initmem(10), (void*) s2, 'b', 10);
	compare_memccpy(initmem(10), (void*) s2, 'b', 3);
	compare_memccpy(initmem(10), (void*) s2, 'c', 10);
	free(s2);
}

void	compare_memmove(char *test, char *s2, size_t length)
{
	void	*result_perso, *result_std;

	printf("\ncpy : %s sur %s sur %zi\n", s2, test, length);
	result_std = cpymem(test);
	result_perso = cpymem(test);
	ft_memmove(result_perso, s2, length);
	memmove(result_std, s2, length);
	print_result((char*) result_std, (char*) result_perso);
}

void	test_memmove()
{
	printf("\n@@@@@@@@@@@@@TEST memmove\n");
	compare_memmove(initmem(10), initmem2(10, 'a'), 10);
	compare_memmove(initmem2(10, 'a'), initmem(10), 10);
}

void	compare_memchr(char *test, int c, size_t n)
{
	void	*result_perso, *result_std;

	printf("\ndans : %s recherche %hhu taille %zi\n", test,
		(unsigned char)c, n);
	result_perso = ft_memchr(test, c, n);
	result_std = memchr(test, c, n);
	print_result((char*) result_std, (char*) result_perso);
}

int				uf_test_memchr(void)
{
	char			ctab[11];
	int				itab[11];
	unsigned long	ltab[11];
	size_t			j;
	int				i;

	i = -300;
	memchr(NULL, 0, 0);
	ft_memchr(NULL, 0, 0);
	while (i < 300)
	{
		j = 0;
		while (j < 11)
		{
			ctab[j] = (char)rand();
			itab[j] = rand();
			ltab[j] = (unsigned long)rand() * LONG;
			j++;
		}
		if (memchr(ctab, i, sizeof(ctab)) != ft_memchr(ctab, i, sizeof(ctab)))
			printf("perso \'%s\' std \'%s\'\n\n", ft_memchr(ctab, i, sizeof(ctab)),
					memchr(ctab, i, sizeof(ctab)));
		if (memchr(itab, i, sizeof(itab)) != ft_memchr(itab, i, sizeof(itab)))
			printf("perso \'%s\' std \'%s\'\n\n", ft_memchr(itab, i, sizeof(itab)),
					memchr(itab, i, sizeof(itab)));
		if (memchr(ltab, i, sizeof(ltab)) != ft_memchr(ltab, i, sizeof(ltab)))
			printf("perso \'%s\' std \'%s\'\n\n", ft_memchr(ltab, i, sizeof(ltab)),
					memchr(ltab, i, sizeof(ltab)));
		++i;
	}
	return (1);
}

void	test_memchr()
{
	printf("\n@@@@@@@@@@@@@TEST memchr\n");
	compare_memchr("0123456789", '5', 10);
	compare_memchr("0123456789", 'p', 10);
	compare_memchr("0123456789", '5', 3);
	uf_test_memchr();

}


void	compare_memcmp(char *s1, char *s2, size_t n)
{
	int		result_perso, result_std;

	printf("\ncompare : %s et %s taille %zi\n", s1, s2, n);
	result_std = memcmp(s1, s2, n);
	result_perso = ft_memcmp(s1, s2, n);
	print_result_int(result_std, result_perso);
}

void	test_memcmp()
{
	printf("\n@@@@@@@@@@@@@TEST memcmp\n");
	compare_memcmp("0123456789", "0123456789", 10);
	compare_memcmp("0123456789", "0123456.89", 10);
	compare_memcmp("0123456789", "0123456.89", 4);
	compare_memcmp("0123456789", "0123456789", 10);
}
