#include "test_str.h"

void	compare_strlen(char *test)
{
	size_t	result_perso, result_std;

	printf("\ntest : %s\n", test);
	result_perso = ft_strlen(test);
	result_std = strlen(test);
	print_result_int((int) result_std, (int) result_perso);
}

/* compare_strlen(NULL); seg fault quand strlen de la bib std*/
void	test_strlen()
{
	printf("\n@@@@@@@@@@@@@TEST STRLEN\n");
	compare_strlen("0123456789");
	compare_strlen("0123\n56789");
	compare_strlen("");
}

void	compare_strdup(char *test)
{
	char	*result_perso, *result_std;

	printf("\ntest : \'%s\'\n", test);
	result_perso = ft_strdup(test);
	result_std = strdup(test);
	print_result(result_std, result_perso);
	free(result_std);
	free(result_perso);
}

/*	compare_strdup(NULL); seg fault quand strdup bibli std*/
void	test_strdup()
{
	printf("\n@@@@@@@@@@@@@TEST STRDUP\n");
	compare_strdup("0123456789");
	compare_strdup("");
}


void	compare_strchr(char *test, int n)
{
	char	*result_perso, *result_std;

	printf("\ntest : \'%s\' et char %i\n", test, n);
	result_perso = ft_strchr(test, n);
	result_std = strchr(test, n);
	print_result(result_std, result_perso);
}

/*	compare_strchr(NULL, (int) '0');segfault bibli std*/
void	test_strchr()
{
	printf("\n@@@@@@@@@@@@@TEST STRCHR\n");
	compare_strchr("0123456789", (int) '5');
	compare_strchr("0123456789", (int) '5');
	compare_strchr("0123456789", 256);
	compare_strchr("0123456789", (int) 'a');
	compare_strchr("0123456789", (int) '\0');
	compare_strchr("", 55);
}

void	compare_strrchr(char *test, int n)
{
	char	*result_perso, *result_std;

	printf("\ntest : \'%s\' et char %i\n", test, n);
	result_perso = ft_strrchr(test, n);
	result_std = strrchr(test, n);
	print_result(result_std, result_perso);
}

/*	compare_strrchr(NULL, (int) '5');segfault bibli std*/
void	test_strrchr()
{
	printf("\n@@@@@@@@@@@@@TEST STRRCHR\n");
	compare_strrchr("0123456789", (int) '5');
	compare_strrchr("0153456789", (int) '5');
	compare_strrchr("0123456789", (int) '0');
	compare_strrchr("0123456789", 256);
	compare_strrchr("0123456789", (int) 'a');
	compare_strrchr("0123456789", (int) '\0');
	compare_strrchr("", 55);
}

void	compare_strstr(char *str, char *wanted)
{
	char	*result_perso, *result_std;

	printf("\nrecherche de \'%s\' dans \'%s\'\n", wanted, str);
	result_perso = ft_strstr(str, wanted);
	result_std = strstr(str, wanted);
	print_result(result_std, result_perso);
}

/*	compare_strstr(NULL, "123"); segfault bibli std*/
void	test_strstr()
{
	printf("\n@@@@@@@@@@@@@TEST STRSTR\n");
	compare_strstr("0123456789", "123");
	compare_strstr("0123456789", "567");
	compare_strstr("0123456789", "aaa");
	compare_strstr("0123456789", "");
	compare_strstr("", "");
	compare_strstr("", "aaa");
}

void	compare_strnstr(char *str, char *wanted, int n)
{
	char	*result_perso, *result_std;

	printf("\nrecherche de \'%s\' dans \'%s\' sur %i\n",
		wanted, str, n);
	result_perso = ft_strnstr(str, wanted, n);
	result_std = strnstr(str, wanted, n);
	print_result(result_std, result_perso);
}

void	test_strnstr()
{
	printf("\n@@@@@@@@@@@@@TEST STRNSTR\n");
	compare_strnstr("0123456789", "123", 5);
	compare_strnstr("0123456789", "123", 2);
	compare_strnstr("0123456789", "aaa", 3);
	compare_strnstr("0123456789", "", 5);
	compare_strnstr("", "", 2);
	compare_strnstr("", "aaa", 3);
}

void	compare_strcmp(char *test1, char *test2)
{
	size_t	result_perso, result_std;

	printf("\ntest : \'%s\' et \'%s\'\n", test1, test2);
	result_perso = ft_strcmp(test1, test2);
	result_std = strcmp(test1, test2);
	print_result_int((int) result_std, (int) result_perso);
}

/*segfault if one of the arguments is NULL*/
void	test_strcmp()
{
	printf("\n@@@@@@@@@@@@@TEST STRCMP\n");
	compare_strcmp("0123456789", "0123456789");
	compare_strcmp("0123456789", "0123456799");
	compare_strcmp("0123456789", "01234567890");
	compare_strcmp("0123456789", "123456789");
	compare_strcmp("", "aaa");
	compare_strcmp("aaaa", "");
	compare_strcmp("", "");
}

void	compare_strncmp(char *test1, char *test2, int n)
{
	size_t	result_perso, result_std;

	printf("\ntest : \'%s\' et \'%s\' sur %i char\n", test1, test2, n);
	result_perso = ft_strncmp(test1, test2, n);
	result_std = strncmp(test1, test2, n);
	print_result_int((int) result_std, (int) result_perso);
}

void	test_strncmp()
{
	printf("\n@@@@@@@@@@@@@TEST STRNCMP\n");
	compare_strncmp("0123456789", "0123456789", 5);
	compare_strncmp("0123456789", "0123456789", 10);
	compare_strncmp("0123456789", "0123456789", 20);
	compare_strncmp("0123456789", "0123456799", 5);
	compare_strncmp("0123456789", "0123456799", 10);
	compare_strncmp("0123456789", "0123456799", 20);
	compare_strncmp("0123456789", "0123", 6);
	compare_strncmp("", "aaa", 0);
	compare_strncmp("aaaa", "", 0);
	compare_strncmp("aaaa", "", 6);
	compare_strncmp("", "", 6);
	compare_strncmp("", "", 0);
}

void	compare_strcpy(char *test)
{
	char	*str_perso;
	char	*str_std;

	str_perso = (char*) malloc(sizeof (char) * ft_strlen(test));
	str_std = (char*) malloc(sizeof (char) * ft_strlen(test));
	str_perso = ft_strcpy(str_perso, test);
	str_std = strcpy(str_std, test);
	print_result(str_std, str_perso);
}

//	compare_strcpy(NULL); le strcpy de la lib std segfault
void	test_strcpy()
{
	printf("\n@@@@@@@@@@@@@TEST strcpy\n");
	compare_strcpy("0123456789");
	compare_strcpy("");
}

void	compare_strncpy(char *test, size_t n)
{
	char	*str_perso;
	char	*str_std;

	str_perso = (char*) malloc(sizeof (char) * ft_strlen(test));
	str_std = (char*) malloc(sizeof (char) * ft_strlen(test));
	printf("\ncopie : \'%s\' sur %zi char\n", test, n);
	str_std = strncpy(str_std, test, n);
	str_perso = ft_strncpy(str_perso, test, n);
	print_result(str_std, str_perso);
}

void	test_strncpy()
{
	printf("\n@@@@@@@@@@@@@TEST strncpy\n");
	compare_strncpy("0123456789", 0);
	compare_strncpy("0123456789", 5);
	compare_strncpy("0123456789", 15);
	compare_strncpy("0123456789", 10);
	compare_strncpy("", 1);
}

void	compare_strcat(char *dst, char *src)
{
	char	*str_perso;
	printf("\nconcat : \'%s\' puis \'%s\'\n", dst, src);
	char	*str_std;
	int 	length;

	length = ft_strlen(src) + ft_strlen(dst);
	str_perso = (char*) malloc(sizeof (char) * length);
	ft_strcpy(str_perso, dst);
	str_std = (char*) malloc(sizeof (char) * length);
	ft_strcpy(str_std, dst);
	str_perso = ft_strcat(str_perso, src);
	str_std = strcat(str_std, src);
	print_result(str_std, str_perso);
}

void	test_strcat()
{
	printf("\n@@@@@@@@@@@@@TEST STRCAT\n");

	compare_strcat("0123456789", "abcd");
	compare_strcat(NULL, "abcd");
	compare_strcat("0123456789", "");
	compare_strcat("", "abcd");
	compare_strcat("", "");
}

void	compare_strncat(char *dst, char *src, size_t n)
{
	char	*str_perso;
	char	*str_std;
	int 	length;

	length = ft_strlen(src) + ft_strlen(dst);
	str_perso = (char*) malloc(sizeof (char) * length);
	ft_strcpy(str_perso, dst);
	str_std = (char*) malloc(sizeof (char) * length);
	ft_strcpy(str_std, dst);
	printf("\nconcat : \'%s\' sur \'%s\' pour %zi char\n", dst, src, n);
	str_perso = ft_strncat(str_perso, src, n);
	str_std = strncat(str_std, src, n);
	print_result(str_std, str_perso);
}

void	test_strncat()
{
	printf("\n@@@@@@@@@@@@@TEST strncat\n");
	compare_strncat("0123456789", "abcd", 2);
	compare_strncat("0123456789", "abcd", 7);
	compare_strncat("0123456789", "abcd", 4);
	compare_strncat("0123456789", "abcd", 0);
	compare_strncat(NULL, "abcd", 5);
	compare_strncat("0123456789", "", 1);
	compare_strncat("", "abcd", 5);
	compare_strncat("", "", 5);
}

void	compare_strlcat(char *test1, char *test2, int n)
{
	size_t	result_perso, result_std;
	char	*buffer_perso, *buffer_std;

	printf("\ntest : \'%s\' et \'%s\' sur %i char\n", test1, test2, n);
	buffer_perso = (char *) malloc(strlen(test1) + strlen(test2));
	strcpy(buffer_perso, test1);
	buffer_std = (char *) malloc(strlen(test1) + strlen(test2));
	strcpy(buffer_std, test1);
	result_perso = ft_strlcat(buffer_perso, test2, n);
	result_std = strlcat(buffer_std, test2, n);
	if (strcmp(buffer_std, buffer_perso))
	{
		printf("#####resulting string are different#####\n");
		printf("perso: %s\n", buffer_perso);
	}
	printf("std  : %s\n", buffer_std);
	print_result_int((int) result_std, (int) result_perso);
	free(buffer_std);
	free(buffer_perso);
}

void	test_strlcat()
{
	printf("\n@@@@@@@@@@@@@TEST STRLCAT\n");
	compare_strlcat("0123456789", "0123456789", 5);
	compare_strlcat("0123456789", "0123456789", 10);
	compare_strlcat("0123456789", "0123456789", 20);
	compare_strlcat("0123456789", "0123", 6);
	compare_strlcat("", "aaa", 0);
	compare_strlcat("aaaa", "", 0);
	compare_strlcat("aaaa", "", 6);
	compare_strlcat("", "", 6);
	compare_strlcat("", "", 0);
}

void	uni_strjoin(char *s1, char *s2)
{
	char	*str;

	printf("\nconcat : \'%s\' sur \'%s\'\n", s1, s2);
	str = ft_strjoin(s1, s2);
	printf("%s\n", str);
}

void	test_strjoin()
{
	printf("\n@@@@@@@@@@@@@TEST strjoin\n");
	uni_strjoin("0123456789", "abcd");
	uni_strjoin("0123456789", "");
}

void	uni_strsplit(char *s, char c)
{
	char	**tab;

	printf("\nsplit : \'%s\' selon %c\n", s, c);
	tab = ft_strsplit(s, c);
	for (int i = 0 ; tab[i] != NULL ; ++i)
		printf("%s#\n", tab[i]);
}

void	test_strsplit()
{
	printf("\n@@@@@@@@@@@@@TEST strsplit\n");
	uni_strsplit("01a23a45a67a89", 'a');
	uni_strsplit("01a23a45a67a89a", 'a');
	uni_strsplit("0123456789", 'a');
	uni_strsplit("*hello", '*');
}

void	uni_strtrim(char *s)
{
	char	*result;

	printf("\ntrim : \'%s\' \n", s);
	result = ft_strtrim(s);
	printf("result : \'%s\'\n", result);
}

void	test_strtrim()
{
	printf("\n@@@@@@@@@@@@@TEST strtrim\n");
	uni_strtrim("  	\n  aaaa 	\n   ");
	uni_strtrim(" 	  aaaa");
	uni_strtrim("aaaa  	   ");
	uni_strtrim("  \t\t\t   ");
	uni_strtrim("");
	uni_strtrim(NULL);
}
